TallTile equ 1				;8x10 tiles on the x68
	ifd BuildNEO
VblankCount equ UserRam+2
	endif
Cursor_X equ UserRam
Cursor_Y equ UserRam+1

GameRam equ (UserRam+256)
ScrWid256 equ 1
TileMap 						equ GameRam;+256	;Added 256 to gamram so we can be certain to be byte alignable
TileMap2 						equ GameRam+768  

KeyboardScanner_KeyPresses		equ GameRam+768+768
PlayerX1	equ KeyboardScanner_KeyPresses+16
RandomSeed 	equ PlayerX1+1
PlayerY1	equ PlayerX1+2
FastGrowth	equ PlayerX1+3		;Fast mould growth
PlayerDir	equ PlayerX1+4		;URDL
BulletX1	equ PlayerX1+5
NothingShot	equ PlayerX1+6		;Time since something last shot
BulletY1	equ PlayerX1+7
AllowedFastGrowth	equ PlayerX1+9
BulletDir	equ PlayerX1+10
PlayingSFX	equ PlayerX1+11
ControlMode	equ PlayerX1+12		;0=1fire mode / 1=2fire mode
GameTick	equ PlayerX1+13		
Lives		equ PlayerX1+14
Animframe	equ PlayerX1+15		;Animation frame (0/16)
Score		equ PlayerX1+16		;8 BCD digits (4 bytes)
HiScore		equ PlayerX1+20		;8 BCD digits (4 bytes)
AnimTick	equ PlayerX1+24		;Animation Tick (0-5)
debouncecount	equ PlayerX1+25	;debounce joystick
randomseed2	equ PlayerX1+26


IXH	equ PlayerX1+27
IXL	equ PlayerX1+28
IYH	equ PlayerX1+29
IYL	equ PlayerX1+30

ScreenWidthG equ 32
ScreenHeightG equ 24
ScreenWidth equ 32
ScreenHeight equ 24

	ifd BuildAST
DefaultControlMode equ 0
	endif
	ifd BuildAMI
DefaultControlMode equ 0
	endif
	ifd BuildGEN
DefaultControlMode equ 1
	endif
	ifd BuildNEO
DefaultControlMode equ 1
	endif
	ifd BuildX68
DefaultControlMode equ 1
	endif

	include "\SrcALL\BasicMacros.asm"
	include "\SrcALL\V1_Header.asm"

	lea Palette,a0					;Define the palette - it's 16 color on all systems
	move.l #17,d4
PaletteNext:
	move.l #17,d0
	sub.b d4,d0
	move.w (a0)+,d1
	jsr SetPalette
	subq.b #1,d4
	cmp.b #0,d4
	bne PaletteNext
	
	move.b #DefaultControlMode,(ControlMode)

	ifd BuildAST					;Turn on the Joystick on the Atari
		jsr KeyboardScanner_AllowJoysticks
	endif
	
	ifd BuildGEN
		lea Bitmap,a0				;Define tiles on the genesis
		move.w #BitmapEnd-Bitmap,d1
		move.l #256*32,d2			;32 bytes per tile
		jsr DefineTiles	
	endif

TitleScreen:
	jsr ForceRepaint				;Reset Tilemap2, so everything redraws
   	jsr ClearScreen	
    
	lea TitlePic,a1
	
	lea TileMap,a2
	move.l a2,d2
	and.b #%11100000,d2
	addq.l #4,d2
	move.l d2,a2					;Clear Bottom byte - need to be byte aligned
	
	move.b #0,d4
TileNextLine:
	move.b #0,d1
TileNextChar:
	move.b (a1)+,(a2)+				;Copy the Title logo to the tilemap
	
	addq.b #1,d1
	cmp.b #24,d1
	bne TileNextChar
	addq.l #8,a2
	
	addq.b #1,d4
	cmp.b #16,d4
	bne TileNextLine

	;move.b #8,d0
	jsr RepaintScreen
		move.b #screenwidthG/2-13,d3 ;Show the highscore message
		move.b #screenheightG-3,d6
		jsr Locate
		lea WebSite,a3
		jsr PrintString
	
	    move.b #screenwidth/2-8,d3	;Show the highscore message
       	move.b #screenheight-5,d6
       	jsr Locate
       	lea HighScoreMessage,a3
       	jsr PrintString
       	lea HiScore,a0				;Show the highscore
       	move.l #3,d1
       	jsr BCD_Show
	
TitleTextReset:						;Scrolling message
       	clr.l d4					;First character in the string to show
TitleAgain:
       	clr.l d5					;No of Chars to skip
       	move.b d4,d1				;Number of characters to show on screen
       	addq.b #1,d1
       	move.b #ScreenWidth-1,d0	;See if Some characters are being skipped
       	sub.b d4,d0
       	bcc TextNotTooLong
       	move.b #ScreenWidth,d1		;We're showing all the characters
       	move.b d4,d0
       	sub.b #(ScreenWidth-1),d0
       	move.b d0,d5				;No of Chars to skip
       	clr.b d0
       	
TextNotTooLong:
       	move.b d0,d3
       	move.b #ScreenHeight-1,d6	;Position the text cursor to the bottom of the screen
       	jsr locate
       	lea ScrollingMessage,a3
       	add.l d5,a3					;skip characters we're past showing
   		clr.l d0
       	move.b -(a3),d0
       	cmp.b #255,d0				;See if we've show all the characters already, 
       	beq TitleTextReset			;If we have, reset the tile array
		
       	addq.l #1,a3     	
TextNextChar:
       	move.b (a3)+,d0				;Load in the next character
		cmp.b #255,d0
       	bne TextNextCharValidChar
		
       	subq.l #1,a3
       	move.b #32,d0				;If we've reached the end of the string, pad it with spaces
TextNextCharValidChar:
       	jsr PrintChar				;Show the character
		subq.b #1,d1
       	bne TextNextChar
       	addq.b #1,d4				;Start from the next character next time
       	pushbc
			move.l #3,d1			;Add some delay on small screen devices
			jsr Pause
			jsr ForceAnimate		;Update 2 sets of framws
			jsr RepaintScreen		;repaint the screen
			addq.b #1,(RandomSeed)
       	;popbc
       	;pushbc
			jsr Player_ReadControlsDual
		popbc
		or.b #Keymap_AnyFire,d0
		cmp.b #255,d0
       	bne NewGame					;Wait until fire is pressed
    jmp TitleAgain					;Update the scrolling text
       
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
NewGame:
	move.b #3,Lives					;Set lives to 3
	clr.l Score						;Clear the score
		
NewGameRound:	
	jsr ClearScreen					;Zero tile array
	jsr RepaintScreen				;repaint screen
	
	move.b #ScreenWidthG/2,d0		;Center player
	move.b d0,(PlayerX1)
	move.b d0,(BulletX1)
	
	move.b #ScreenHeightG/2,d0
	move.b d0,(PlayerY1)
	move.b d0,(BulletY1)
	
	moveq.l #4,d0					;Aim player Left
	move.b d0,(PlayerDir)
	move.b d0,(BulletDir)
	
	moveq.l #4,d0					;Start the game with fast growth
	move.b d0,(AllowedFastGrowth)
	
	jsr CreateInvader				;Create two invaders at the start of the game
	jsr CreateInvader
	
	clr.b d0 						;Reset Game Ticks
	move.b d0,(GameTick)
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
GameLoop:
	jsr GetRandom					;Pull a random number
	and #%11111110,d0				;invader/descender happens 1 in 128
	cmp.b #192,d0
	bne GameLoopA
	jsr CreateInvader				;Create an invaider
	
GameLoopA:
	cmp.b #128,d0
	bne GameLoopB
	jsr CreateDescender				;Create a descender

GameLoopB:
	move.b (FastGrowth),d0
	beq NoFastGrowth				;If FastGrowth counter is >0 then we grow every frame
	subq.b #1,(FastGrowth)
	bra DoGameEvolve

NoFastGrowth:	
	move.b (GameTick),d0			;Increase the gametick
	addq.b #1,d0
	move.b d0,(GameTick)
	and #%00111111,d0				;Frequency of evoloution
	bne DoGameMove

DoGameEvolve:
	jsr MouldEvolve					;Evolve the mould
	jsr RepaintScreen
	bra ProcessPlayer	
	
DoGameMove:	
	and.b #%00000001,d0
	bne DoGamePause
	jsr MouldMove					;Move the mould
	jsr RepaintScreen
	bra ProcessPlayer	
	
DoGamePause:
	jsr RepaintScreen
	jsr ForceAnimate				;Animate the mould
	move.l #1,d1
	jsr pause 

ProcessPlayer:	
	clr.b d3
	clr.b d6
	jsr Locate						;Print Score on top left, except on TI
	lea Score,a0
	move.l #4-1,d1
	jsr BCD_Show
	move.b #ScreenWidth-2,d3
	clr.b d6
	 
	jsr Locate						;Print Lives on top right
	move.b #"L",d0
	jsr PrintChar
	move.b (Lives),d0
	add.b #"0",d0
	jsr PrintChar
	
	move.b (NothingShot),d0			;Is the player busy?
	addq.b #1,d0
	and.b #%00011111,d0
	cmp.b #31,d0
	bne PlayerActive
	
	jsr CreateInvader				;player is slacking, so lets spawn some stuff
	jsr CreateInvader
	jsr CreateDescender
	move.b  #2,(AllowedFastGrowth)	;Fast grow the mould for a few frames
	clr.b d0
	
PlayerActive:	
	move.b d0,(NothingShot)
	move.b (PlayerX1),d1			;Read in the current location to BC
	move.b (PlayerY1),d4
	jsr findtile					;Get the tile location of the player, we need this to check uf the player is alive
									;if the player is surrounded on UDLR then the player is dead
	move.b d1,d0 
	cmp.b #0,d0
	beq PlayerFarLeft				;Player is at far left, we can't check that direction
	
	subq.l #1,a3
	move.b (a3),d0 
	cmp.b #8,d0
	bcs PlayerStillAlive			;Player is not surrounded on left
	
	addq.l #1,a3
PlayerFarLeft:
	addq.l #1,a3
	move.b d1,d0
	cmp.b #ScreenWidthG-1,d0			
	beq PlayerFarRight				;Player is far right, we can't check that direction
	
	move.b (a3),d0
	cmp.b #8,d0
	bcs PlayerStillAlive			;Player is not surrounded on right
	
PlayerFarRight:
	add.l #-33,a3
	move.b d4,d0 
	cmp.b #0,d0
	beq PlayerFarTop				;player is at top of screen, we can't check that direction
	
	move.b (a3),d0 
	cmp.b #8,d0
	bcs PlayerStillAlive			;Player is not surrounded at top
	
PlayerFarTop:
	add.l #64,a3
	move.b d4,d0
	
	cmp.b #ScreenHeightG-1,d0
	beq PlayerFarBottom				;Player is at bottom of screen, we can't check that direction
	move.b (a3),d0
	
	cmp.b #8,d0
	bcs PlayerStillAlive			;Player is not surrounded from bottom
	
PlayerFarBottom:
	bra PlayerDead					;Player is dead!
	
PlayerStillAlive:	
	pushbc
		jsr Player_ReadControlsDual
	popbc
	move.b d0,d3
	move.b (PlayerDir),d6 			;Load in the player direction into L (UDLR=1234)

	clr.b (PlayingSFX)  			;Reset the sound effects
	
	bTst #0,(ControlMode)			;Check the control mode (1fire 2fire)
	bne ControlMode2Fire
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;												Single Fire Mode (1 firebutton)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
F1_ControlMode1Fire:				;1fire mode
	btst #Keymap_U,d3
	bne F1_PlayerNotUp
	btst #Keymap_F1,d3				;Up button is pressed
	beq FireFaceUp
	cmp.b #0,d4
	beq F1_PlayerNotUp
	subq.b #1,d4 					;Move player down
	bra F1_PlayerNotUp

FireFaceUp:
	moveq.l #1,d6 					;Set fire direction to down
F1_PlayerNotUp:
	 btst #Keymap_D,d3
	 bne F1_PlayerNotDown
	 btst #Keymap_F1,d3				;Down button pressed
	 beq FireFaceDown
	 ;ld a,c
	 cmp.b #ScreenHeightG-1,d4
	 beq F1_PlayerNotDown
	 addq.b #1,d4					;Move player up
	 bra F1_PlayerNotDown

FireFaceDown:
	 moveq.l #3,d6					;Set fire direction to up	 
F1_PlayerNotDown:
	btst #Keymap_L,d3
	bne F1_PlayerNotLeft
	btst #Keymap_F1,d3				;Left button pressed
	beq FireFaceLeft
	move.b d1,d0 
	cmp.b #0,d0
	beq F1_PlayerNotLeft
	subq.b #1,d1 					;Move player left
	bra F1_PlayerNotLeft

FireFaceLeft:
	moveq.l #4,d6 					;Set fire direction to left
F1_PlayerNotLeft:
	btst #Keymap_R,d3
	bne F1_PlayerNotRight
	btst #Keymap_F1,d3				;Right button pressed
	beq FireFaceRight
	cmp.b #ScreenWidthG-1,d1
	beq F1_PlayerNotRight
	addq.b #1,d1 					;Move player right
	bra F1_PlayerNotRight

FireFaceRight:	
	moveq.l #2,d6 					; Set fire direction to right
F1_PlayerNotRight:
	 btst #Keymap_F1,d3
	 bra PlayerNotFire2				;Continue control processing
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;												Alt Fire Mode (2 firebutton)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ControlMode2Fire:		
	cmp.b #0,(debouncecount)
	beq DebounceCheck
	subq.b #1,(debouncecount)
 	bra PlayerNotPause
	
DebounceCheck:						;Ignore fire if recentply pressed
	move.b d3,d0 
	or.b #Keymap_AnyFire,d0
	cmp.b #255,d0
	beq DebounceOK
	move.b #2,(debouncecount)		;Fire just pressed, so skip next few checks

DebounceOK:	
	btst #Keymap_U,d3
	bne PlayerNotUp				
	cmp.b #0,d4
	beq PlayerNotUp
	subq.b #1,d4 					;Move player up
PlayerNotUp:
	btst #Keymap_D,d3
	bne PlayerNotDown
	cmp.b #ScreenHeightG-1,d4
	beq PlayerNotDown
	addq.b #1,d4					;Move player down
PlayerNotDown:
	btst #Keymap_L,d3
	bne PlayerNotLeft
	cmp.b #0,d1
	beq PlayerNotLeft
	subq.b #1,d1					;Move player left
PlayerNotLeft:
	btst #Keymap_R,d3
	bne PlayerNotRight
	cmp.b #ScreenWidthG-1,d1
	beq PlayerNotRight
	addq.b #1,d1 					;Move player right
PlayerNotRight:
	 btst #Keymap_F1,d3
	bne PlayerNotFire
	subq.b #1,d6  					;Rotate player left
	bne PlayerDirReset
	moveq.l #4,d6
PlayerDirReset:	
PlayerNotFire:
	 btst #Keymap_F2,d3
	bne PlayerNotFire2
	addq.b #1,d6 					;Rotate player right
	cmp.b #5,d6
	bne PlayerDirReset2
	moveq.l #1,d6
PlayerDirReset2:	
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;												This section is used by both control modes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
PlayerNotFire2:
	btst #Keymap_F3,d3
	bne PlayerNotFire3
	move.b (ControlMode),d0			;Fire 3 (enter) swaps control modes
	eori.b #$FF,d0
	move.b d0,(ControlMode)
	jsr Debounce					;Wait for fire key to be released
 PlayerNotFire3:
	 btst #Keymap_Pause,d3
	 bne PlayerNotPause
	 pushbc
	 pushhl
		 move.b #ScreenWidth/2-3,d3
		 move.b #ScreenHeight/2,d6
		 jsr Locate
		 lea PauseMessage,a3
		 jsr PrintString			;Show pause message
	
		 jsr WaitForFire			;Wait for player to press fire
		 jsr ForceRepaint
		 jsr RepaintScreen
	 pophl
	 popbc
PlayerNotPause:
	move.b (PlayerDir),d0			;Check if we need to update the player sprite
	cmp.b d0,d6
	bne PlayerMoved
	
	move.b (PlayerX1),d0
	cmp.b d0,d1
	bne PlayerMoved
	
	move.b (PlayerY1),d0
	cmp.b d0,d4
	bne PlayerMoved
	bra PlayerUnmoved				;Player position/direction unchanged

PlayerMoved:	
	move.b d6,d0 ;ld a,l
	move.b d0,(PlayerDir)
	jsr FindTile
	move.b (a3),d0					;check if direction player wants to move is empty
	cmp.b #0,d0
	bne PlayerUnmoved			
	
	pushbc
		move.b (PlayerX1),d1		;Update player location
		move.b (PlayerY1),d4
		jsr FindTile	
		clr.b (a3)					;Clear player sprite from old location
		jsr RenderTile
	popbc
	move.b d1,(PlayerX1) 
	move.b d4,(PlayerY1)			;Store in the new player location
	
PlayerUnmoved:
	move.b (BulletX1),d1			;Get current bullet location
	move.b (BulletY1),d4
	pushbc
		jsr FindTile	
		clr.b (a3)
		jsr RenderTile				;Clear current bullet sprite
	popbc
	move.b #4,(ixl)					;Bullet moves per tick
BulletRecalc:
	move.b (BulletDir),d0			;Bullet Direction
	cmp.b #1,d0
	beq BulletUp
	cmp.b #2,d0
	beq BulletRight
	cmp.b #3,d0
	beq BulletDown
	cmp.b #4,d0
	beq BulletLeft
BulletUp:
	subq.b #1,d4 					;Up
	bra BulletCheck
BulletDown:
	addq.b #1,d4 					;Down
	bra BulletCheck
BulletLeft:
	subq.b #1,d1 					;Left
	bra BulletCheck
BulletRight:
	addq.b #1,d1  					;Right
BulletCheck:
	cmp.b #ScreenWidthG,d1
	bcc BulletRestart				;If bullet has gone ofscreen we need to make a new one
	cmp.b #ScreenHeightG,d4
	bcc BulletRestart

	jsr FindTile	
	move.b (a3),d0 					;Read in the object under the bullet
	bne BulletStrike				;Jump if bullet hit something
	
	subq.b #1,(ixl)
	bne BulletRecalc				;Move bullet again for next tick
	
	bra BulletDraw
BulletRestart:
	move.b (PlayerDir),d0			;Bullet has gone offscreen, so create a new one at player location
	move.b d0,(BulletDir)
	move.b (PlayerX1),d1
	move.b (PlayerY1),d4
	jsr FindTile
	
BulletDraw:
	move.b d1,(BulletX1)			;Store bullet location
	move.b d4,(BulletY1)
	move.b #5,(a3)
	jsr RenderTile
	
	 move.b (PlayerX1),d1			;Reload the player location
	 move.b (PlayerY1),d4
	 
	 jsr FindTile
	 ;
	 move.b (PlayerDir),d0			;Draw the player sprite
	 move.b d0,(a3)
	 jsr RenderTile
TestSkip
	move.b (PlayingSFX),d0			;Play the current soundeffect (0=nosound)
	jsr ChibiSound
	bra GameLoop
	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	
BulletStrike:				;Players bullet has hit something
	pushbc
		pushhl
			lea BCD1,a1			;Seeker Score
			move.b #%10000001,d1	;Seeker Sound
			cmp.b #10,d0
			beq ApplyScore
			lea BCD3,a1			;Blue Mould Score
			move.b #%10000111,d1	;Blue Mould Sound
			cmp.b #9,d0
			beq ApplyScore
			lea BCD5,a1			;Green Mould Score
			move.b #%10000111,d1	;Green Mould Sound
			cmp.b #8,d0				
			beq ApplyScore
			lea BCD20,a1			;Invader/Descender Score
			move.b #%10001111,d1	;Invader/Descender Sound
ApplyScore:
			move.b d1,(PlayingSFX)	;Make a sound
			lea Score,a0
			move.l #3,d1
			jsr BCD_Add				;Add the score
		pophl
	popbc
	clr.b (a3)
	jsr RenderTile					;Remove the enemy from the tilemap
	
	clr.b (NothingShot)
	clr.b (AllowedFastGrowth)		;Player is busy, so stop fast growth
		
	jsr GetRandom					;Add some randomization
	bra BulletRestart
	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MouldEvolve:								;Evolve the mould (full tick)

	lea TileMap2,a3				;Get the alt tilemap
	move.l a3,d3
	and.b #%11100000,d3			;Clear Bottom byte - need to be byte aligned
	move.l d3,a3	
	move.b #0,d4
MouldEvolve_NextY:
	move.b #0,d1
MouldEvolve_NextX:
	move.b (a3),d0				;Get the current tile
	pushhl
		sub.l #768,a3			;subtract 768, because we want to see the previous state.
		cmp.b #8,d0
		beq MouldEvolve_Green	;Evolve a cell of green mould
		cmp.b #9,d0
		beq MouldEvolve_Blue	;Evolve a cell of blue mould
		cmp.b #12,d0
		bne MouldEvolveC
		jsr DoDescender			;Move a descender down
MouldEvolveC
		cmp.b #11,d0
		bne MouldEvolveD
		jsr DoInvader			;Move an invader left
MouldEvolveD
		cmp.b #10,d0
		bne MouldEvolveE
		jsr DoMouldSeek			;Move a seeker towards the player
MouldEvolveE
MouldEvolve_Next:
	pophl
	addq.l #1,a3
	addq.b #1,d1
	cmp.b #32,d1
	bne MouldEvolve_NextX
	addq.b #1,d4
	cmp.b #24,d4
	bne MouldEvolve_NextY
	rts
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MouldMove:						;Move the mould (partial tick)
	eor.b #%00010000,(Animframe) ;Force animation

	lea TileMap2,a3				;Get the alt tilemap
	move.l a3,d3
	and.b #%11100000,d3			;Clear Bottom byte - need to be byte aligned
	move.l d3,a3	
	
	clr.b d4
MouldMove_NextY:
	clr.b d1
MouldMove_NextX:
	move.b (a3),d0				;Get the current tile
	pushhl
		sub.l #768,a3			;subtract 768, because we want to see the previous state.
		cmp.b #12,d0
		bne MouldMoveA
		jsr DoDescender			;Move a descender down
MouldMoveA
		cmp.b #11,d0
		bne MouldMoveB
		jsr DoInvader			;Move an invader left
MouldMoveB
		cmp.b #10,d0
		bne MouldMoveC
		jsr DoMouldSeek			;Move a seeker towards the player
MouldMoveC
	pophl
	addq.l #1,a3
	addq.b #1,d1
	cmp.b #32,d1
	bne MouldMove_NextX
	addq.b #1,d4
	cmp.b #24,d4
	bne MouldMove_NextY
	rts
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
DoDescender:
	cmp.b #ScreenHeightG-1,d4
	beq ZeroCurrent
	move.b (a3),d2
	
	pushbc
	pushhl	
		add.l #32,a3						;Move down a line
		move.b (a3),d0						;Read in the object under the descender
		beq DescenderDone
		cmp.b #5,d0
		bcs PlayerDead						;See if the descender has hit the player	<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
		bne NoZeroBullet
		clr.b d0							;don't copy player sprites!
NoZeroBullet:
		cmp.b #9,d0
		beq DescenderToGreen				;Convert Blue mould to green
		cmp.b #10,d0
		beq DescenderToBlue					;Convert seekers to blue mould
		bra DescenderDone
DescenderToBlue:
		moveq.l #9,d0						;Blue Mould
		bra DescenderDone
DescenderToGreen:
		moveq.l #8,d0						;Green Mould
DescenderDone:
		move.b d2,(a3)
	pophl
	popbc
	move.b d0,(a3)
	clr.b d0	
	rts
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DoInvader:
	move.l a3,d0
	and.b #%00011111,d0
	beq ZeroCurrent							;We've reached the left hand side of the screen, so remove the invader
	
	move.b (a3),d2 
	subq.l #1,a3
	move.b (a3),d0
	beq InvaderDone
	
	cmp.b #5,d0
	bcs PlayerDead							;We've hit the player, so they player is dead 	
	bne NoZeroBullet2
	
	clr.b d0								;Don't copy player sprites
NoZeroBullet2:
InvaderDone:
	move.b d2,(a3)+
	move.b d0,d2 
	cmp.b #8,d0
	bcc DoInvader_NoSpore					;Don't drop a spore on non-empty spaces

	jsr GetRandom							;We drop spores at random
	and.b #%00011111,d0
	bne DoInvader_NoSpore
	
	move.b (AllowedFastGrowth),(FastGrowth)	;We're making a spore, so speed up the growth for a few ticks
	move.b #8,d0
	bra DoInvader_NewSpore					;Drop a new spore
	
DoInvader_NoSpore:	
	move.b d2,d0
DoInvader_NewSpore:	
	move.b d0,(a3)
	clr.b d0
	rts
ZeroCurrent:
	clr.b (a3)
	;ld (hl),0								;Clear the cell
	clr.b d0
	;xor a
	rts
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DoMouldSeek:
	move.l a3,a2					;Load current location into DE
	move.b (PlayerX1),d0			;Compare to player X
	cmp.b d1,d0
	beq DoMouldMove_SkipX
	bcc DoMouldMove_XSmaller
		subq.l #1,a2				;Move left
		bra DoMouldMove_SkipX
DoMouldMove_XSmaller:
		addq.l #1,a2				;Move right
DoMouldMove_SkipX:	
	move.b (PlayerY1),d0			;Compare to player Y
	cmp.b d4,d0	
	beq DoMouldMove_SkipY
	bcc DoMouldMove_YSmaller
		sub.l #32,a2				;Move up
		bra DoMouldMove_SkipY
DoMouldMove_YSmaller:
		add.l #32,a2				;Move down
DoMouldMove_SkipY:	
	move.b (a2),d0
	beq SeekOK
	cmp.b #5,d0						;Bullet
	beq SeekOK
	rts
SeekOK:
	move.b (a3),(a2)				;Move to the new location, clear the old one
	clr.b (a3)
	rts
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
MouldEvolve_Green:
	move.b #9,(ixl)				;Center objects (seeeker)
	move.b #8,(ixh)				;Edge objects (green)
	bra DoMouldEvolve
	
MouldEvolve_Blue:
	move.b #10,(ixl)			;Center object (Seeker)
	move.b #9,(ixh)				;Edge object (Blue)
	bra DoMouldEvolve

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
DoMouldEvolve:
		move.b (ixl),(a3)		;New Center spore
		addq.l #1,a3			;Move Right
		move.l a3,d0
		and.b #%00011111,d0		;See if we're off the screen
		beq MouldEvolve_GreenSkip1
		
		move.b (a3),d0
		bne MouldEvolve_GreenSkip1
		
		move.b (ixh),(a3)		;New Outer spore
MouldEvolve_GreenSkip1:
		subq.l #2,a3			;Move to center
		move.l a3,d0
		and.b #%00011111,d0
		beq MouldEvolve_GreenSkip2

		move.b (a3),d0			;See if we can drop a spore
		bne MouldEvolve_GreenSkip2
		
		move.b (ixh),(a3)		;New Outer spore
MouldEvolve_GreenSkip2:
		add.l #33,a3			;Move to Center+Move Down
		cmp.b #24,d4			;See if we're off the bottom of the screen
		beq MouldEvolve_GreenSkip3b
		
		move.b (a3),d0 
		bne MouldEvolve_GreenSkip3
		
		move.b (ixh),(a3)		;New Outer spore
MouldEvolve_GreenSkip3:
		cmp.b #0,d4				;See if we're offscreen
		beq MouldEvolve_GreenSkip4
		
MouldEvolve_GreenSkip3b:
		sub.l #64,a3			;Move Up
		move.b (a3),d0
		bne MouldEvolve_GreenSkip4
		
		move.b (ixh),(a3)		;New Outer spore
MouldEvolve_GreenSkip4:
	bra MouldEvolve_Next

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RepaintScreen:
	move.b #0,d3			;We repaint the screen in 4 sections,
	move.b #0,d6			;this updates in a checkerboard effect, and makes the refresh less visible			
	jsr DoFill	
	
	move.b #1,d3
	move.b #1,d6
	jsr DoFill
	
	move.b #0,d3
	move.b #1,d6
	jsr DoFill
	
	move.b #1,d3
	move.b #0,d6
	jmp DoFill
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
DoFill:	
	move.b d6,d4				;Start Y
FillCAgain:
	move.b d3,d1 				;Start X
FillBAgain:
	pushbc
	pushhl
		jsr FindTile
		clr.l d0
		move.b (a3),d0
		add.l #768,a3			;Adding 768 moves us to tilemap2 (the cache copy)
		cmp.b (a3),d0			;Compare new tile to old one
		beq DoFillSkipTile
		move.b d0,(a3)
		jsr RenderTile			;Render the tile if it's not changes
DoFillSkipTile:
	pophl
	popbc
	addq.b #2,d1				;We move in twos because we run the routine 4 time 
	cmp.b #ScreenWidthG,d1		;to make the update look nicer and avoid a wiping effect
	blt FillBAgain
	addq.b #2,d4
	cmp.b #ScreenHeightG,d4
	blt FillCAgain
	rts
	
FindTile:						;Convert a BC (XY) co-ordinate to a memory location

	lea TileMap,a3				;Get the tilemap
	move.l a3,d3
	and.b #%11100000,d3			;Clear Bottom 5 bits - need to be byte aligned
	move.l d3,a3		
	
FindTileAlt:
		and.l #$FF,d1
		and.l #$FF,d4
		move.l d4,d2			;32 tiles per Y line - so 5 bitshifts
		rol.l #5,d2
		add.l d1,a3
		add.l d2,a3
	rts
	
RenderTile:						;Draw the tile
		and.l #$FF,d1
		and.l #$FF,d4		
		jsr FindTile		
		move.b (a3),d0
		or.b (Animframe),d0		;Read in our Animation frame (0/16)
		and.l #$FF,d0
	jmp ShowTile	
	
ClearScreen:					;Clear the tilemap
	lea TileMap,a3				;Get the tilemap
	move.l a3,d3
	and.b #%11100000,d3
	move.l d3,a3				;Clear Bottom 5 bits - need to be byte aligned
	
	move.b #0,d0
	move.l #768-1,d1
	jsr CLDIR
;	jsr ForceRepaint			; and force a repaint
;	rts
		
ForceRepaint:					;Force a repaint of the whole tilemap (including blanks spaces)
		lea TileMap2,a3			;Get the alt tilemaps
		move.l a3,d3
		and.b #%11100000,d3		;clear bottom 5 bits to align tilemap
		move.l d3,a3		
		
		move.b #255,d0			;Force a repaint by setting all the alt tilemap to tile 255
		move.l #768-1,d1
		jmp CLDIR
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ForceAnimate:
		move.l #(768/6),d1				;We animate 1/6 tiles each time, this keeps each frame fast, and makes the the frames that animate look 'random'
		moveq.l #6,d2
		addq.l #1,d1					;Need to inc b for the loop to work
		
		lea TileMap2,a3					;Get the Alt Tilemap
		move.l a3,d3
		and.b #%11100000,d3				;Clear Bottom 5 bits - need to be byte aligned
		move.l d3,a3					
		
		move.b (AnimTick),d0
		addq.b #1,d0
		cmp.b #6,d0						;See if the 6 sets have all been animated
		bne ForceAnimate_UpdateL			
	
		eor.b #%00010000,(Animframe)	;Flip to the 2nd frame

		clr.b d0
		move.b d0,(AnimTick)			;Reset animation tick
		bra ForceAnimateAgain
		
ForceAnimate_UpdateL:	
		move.b d0,(AnimTick)			;Reset the tick
		clr.l d0
		move.b (AnimTick),d0
		add.l d0,a3
ForceAnimateAgain:
		cmp.b #0,(a3)					;We don't mess with 0 tiles, as it slows things down and causes problems
		beq CellSkip					;this relies on A=0 when this routine starts
		move.b #255,(a3)				;Set the 'oldtile' to 255... this forces a repaint
CellSkip:
		add.l d2,a3
		subq.l #1,d1
		bne ForceAnimateAgain
	rts



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
pause:					;Wait for a d1 Vblanks
	pushall
		jsr waitVBlank
	popall 	
	dbra d1,pause
	rts
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Debounce:				;Wait for all keys to be released
		pushhl
		pushbc
			jsr Player_ReadControlsDual
		popbc
		pophl
		cmp.b #255,d0
		bne Debounce			
	rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

WaitForFire:	
	jsr debounce				;Wait for keys to be released
WaitForFire2:
	pushhl
		jsr Player_ReadControlsDual
	pophl
	or.b #Keymap_AnyFire,d0
	cmp.b #255,d0
	beq WaitForFire2			;Wait for any key to be pressed
	rts
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CreateDescender:
	jsr GetRandom			;Get a random column
	and.l #%00011111,d0
	
	lea TileMap,a3
	move.l a3,d3
	and.b #%11100000,d3
	move.l d3,a3				;Clear Bottom byte - need to be byte aligned	
	add.l d0,a3
	
	move.b #12,(a3)
	clr.b d0
	rts
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	

CreateInvader:
	jsr GetRandom					;Get a random row
	and.b #%00011111,d0
	cmp.b #ScreenHeightG,d0
	bcc CreateInvader				;Get a number 0-screenheight
	
	lea TileMap,a3
	move.l a3,d3
	and.b #%11100000,d3
	move.l d3,a3					;Clear Bottom byte - need to be byte aligned
	
	clr.l d1
	move.b d0,d1
	
	rol.l #5,d1
	add.l #ScreenWidthG-1,d1		;Far right of screen
	add.l d1,a3
	
	move.b #11,(a3)
	clr.b d0
	rts
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
PlayerDead:							;Player has been killed
	move.l #1000,d1

PlayerDead_SpotRepeat:
	pushbc
		jsr GetRandom				;Pick a random column between 0-31
		and.l #%00011111,d0
		
		lea TileMap,a3
		move.l a3,d3
		and.b #%11100000,d3
		move.l d3,a3				;Clear Bottom byte - need to be byte aligned
		
		add.l d0,a3 
		clr.b d1
PlayerDead_SpotSeek:
		move.b (a3),d0
		
		cmp.b #13,d0				;Check if the column is showing our gameover grime
		bne PlayerDead_FoundSpot
		add.l #32,a3				;If it is, move down until we find an empty spot
		addq.b #1,d1
		
		cmp.b #ScreenHeightG-1,d1
		beq PlayerDead_FoundSpot	;We've got to the end of the screen.
		bra PlayerDead_SpotSeek
PlayerDead_FoundSpot:
		move.b #13,(a3)				;Set the tile to our gameover gri,e
		
	popbc
	pushbc
		move.b d1,d0 
		and.b #%00001111,d0
		bne PlayerDead_NoRedraw		;only update the screen each 16 tiles
		
		move.b d1,d0 
		and.b #%11110000,d0			;Change the counter to a sound effect
		ror.b #4,d0
		move.b d0,d4
		move.w d1,d0
		and.w #%0000111100000000,d0
		ror.w #4,d0
		or.b d4,d0
		eor.b #%00111111,d0
		or.b  #%10000000,d0
		jsr ChibiSound				;Make the sound
		jsr ForceAnimate
		jsr RepaintScreen			;Update the screen
		move.l #$0,d1				;Add some delay on small screen devices
		jsr Pause
PlayerDead_NoRedraw:		
	popbc
	
	subq.l #1,d1
	bne PlayerDead_SpotRepeat	;Continue the gameover animation
	
	clr.b d0
	jsr ChibiSound				;stop the sound
	
	lea TileMap,a3
	move.l a3,d3
	and.b #%11100000,d3
	move.l d3,a3		;Clear Bottom byte - need to be byte aligned
			
	move.b #13,d0
	move.l #768-1,d1
	jsr cldir
	jsr RepaintScreen			;We may not have actually filled the screen with grime, so lets force-fill it here
	
	move.l #$10,d1		;Add some delay on small screen devices
	jsr Pause
	
	subq.b #1,(Lives)				;Decrease the lives	
	bne NewGameRound			;If the player has lives left, keep playing
		
	move.b #(ScreenWidth/2)-7+1,d3
	move.b #(ScreenHeight/2)-3,d6
	
	jsr Locate
	lea GameOver,a3 				;Print the gameover message
	jsr PrintString	
	
	move.b #(ScreenWidth/2)-8,d3
	move.b #(ScreenHeight/2)+1,d6
	jsr Locate 
	
	lea GameOver2,a3				;Print the yousuck messaage
	jsr PrintString
	
	move.l  (Score),d0
	cmp.l (HiScore),d0
	bcs GameOverWaitForFire
	
	move.b #(ScreenWidth/2)-7+1,d3
	move.b #(ScreenHeight/2)+4,d6

	jsr Locate
	lea NewHiscore,a3
	jsr PrintString			;Show the 'new highscore' message
	
	move.l  (Score),d0	;update the highscore
	move.l d0,(HiScore)
GameOverWaitForFire:
	jsr WaitForFire				;Pause, then restart the game
	bra TitleScreen
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
GetRandom:		;Return a random number in d0
		moveM.l d1-d7/a0-a7,-(sp)
			
			clr.l d0
			lea RandomSource,a4
			move.b (randomseed),d0
			and.b #%00000111,d0
			move.b (0,a4,d0),d7			;Read one of the 8 randomsource bytes 
			move.b  (randomseed),d6
			eor.b d6,d7					;XOR it in
			
			move.b (randomseed),d0
			and.b #%00111000,d0			;use another 3 bits from the source
			ror.b #3,d0
			move.b (0,a4,d0),d6		
			eor.b d6,d7					;XOR it in too

			clr.l d0
			move.b randomseed2,d0
			lea GameLoop,a4				;Take a random byte of the source code!
			move.b (0,a4,d0),d6
			eor.b d6,d7					;XOR it in too!
			
			move.b d7,d0
			and.l #$FF,d0				;Limit to 1 byte
			
			addq.b #1,(randomseed)		;Inc the seeds
			addq.b #3,(randomseed2)
			
		moveM.l (sp)+,d1-d7/a0-a7
	rts
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	

	include "\SrcALL\V1_ReadJoystick.asm"
	include "\SrcALL\V1_VdpMemory.asm"
	include "\SrcALL\V1_ChibiSound.asm"
	
	include "\SrcALL\V1_BitmapMemory.asm"
	include "\SrcAll\V1_Palette.asm"
	
	include "\SrcALL\V1_Functions.asm"
	include "\SrcALL\Multiplatform_Monitor.asm"
	
	include "\SrcALL\BasicFunctions.asm"	
	include "\SrcALL\V1_SimpleTile.asm"
	include "\SrcALL\V1_DataArea.asm"
	include "\SrcALL\Multiplatform_BCD.asm"
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;				Data Area
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	ifnd BuildNEO			;NeoGeo Doesn't use font or Tiles (they are in the fixmap)
Font:
		incbin "\ResALL\Font96.FNT"
	endif
Bitmap:
	ifd BuildX68
		incbin "\ResALL\Sprites\GrimeX68.RAW"
		incbin "\ResALL\Sprites\GrimeX682.RAW"
	endif	
	ifd BuildGEN
		;incbin "\ResALL\Sprites\RawMSXVdp.RAW"
		incbin "\ResALL\Sprites\GrimeGEN.RAW"
		incbin "\ResALL\Sprites\GrimeGEN2.RAW"
	endif
	ifd BuildAST
		incbin "\ResALL\Sprites\GrimeAST.RAW"
		incbin "\ResALL\Sprites\GrimeAST2.RAW"
	endif
	ifd BuildAMI
		incbin "\ResALL\Sprites\GrimeAMI.RAW"
		incbin "\ResALL\Sprites\GrimeAMI2.RAW"
	endif
BitmapEnd:
	even
RandomSource: dc.b $8B,$0D,$1A,$52,$9C,$4E,$F6,$37
Palette:
	;     -grb
	dc.w $0000;0  -GRB
	dc.w $0555;1  -GRB
	dc.w $0AAA;2  -GRB
	dc.w $0FFF;3  -GRB
	dc.w $0900;4  -GRB
	dc.w $0E05;5  -GRB
	dc.w $0518;6  -GRB
	dc.w $061F;7  -GRB
	dc.w $08B0;8  -GRB
	dc.w $0DF2;9  -GRB
	dc.w $038E;10  -GRB
	dc.w $00FF;11  -GRB
	dc.w $0080;12  -GRB
	dc.w $00F0;13  -GRB
	dc.w $0A18;14  -GRB
	dc.w $0F7B;15  -GRB
	dc.w $0000	;Border
	even
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
BCD1: dc.b  $00,$00,$00,$01	;1 		Score 'adders' for BCD... 
BCD3: dc.b  $00,$00,$00,$03	;3		my BCD requires value to add to match in length destination score
BCD5: dc.b  $00,$00,$00,$05	;5
BCD20: dc.b $00,$00,$00,$20	;20
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;				
TitlePic:		;GRIME 68000 Logo

	dc.b 0,0,0,9,9,0,9,9,9,0,0,9,0,0,9,9,9,0,9,0,9,9,0,0
	dc.b 9,0,9,0,0,9,9,0,0,9,9,0,9,9,0,9,0,9,9,9,0,0,9,0
	dc.b 0,9,0,13,13,0,0,13,13,0,0,13,0,0,13,0,13,0,9,0,13,13,0,9
	dc.b 9,0,13,0,0,0,0,13,0,13,0,13,0,13,0,13,0,13,0,13,0,0,9,0
	dc.b 9,0,13,0,13,13,0,13,13,0,0,13,0,13,0,0,0,13,0,13,13,0,9,0
	dc.b 9,0,13,0,0,13,0,13,0,13,0,13,0,13,0,9,0,13,0,13,0,0,9,0
	dc.b 0,9,0,13,13,0,0,13,0,13,0,13,0,13,0,9,0,13,0,0,13,13,0,9
	dc.b 9,0,9,0,0,0,9,0,0,0,9,0,0,0,9,9,0,9,0,9,0,0,9,0
	dc.b 0,9,9,0,13,13,0,0,13,0,9,0,13,0,9,0,13,0,9,0,13,0,9,9
	dc.b 0,9,0,13,0,0,0,13,0,13,0,13,0,13,0,13,0,13,0,13,0,13,0,9
	dc.b 0,9,0,13,13,0,9,0,13,0,0,13,0,13,0,13,0,13,0,13,0,13,0,9
	dc.b 9,9,0,13,0,13,0,13,0,13,0,13,0,13,0,13,0,13,0,13,0,13,0,9
	dc.b 0,9,9,0,13,0,9,0,13,0,9,0,13,0,9,0,13,0,9,0,13,0,9,0
	dc.b 0,0,9,9,0,9,9,9,0,9,9,9,0,9,9,9,0,9,9,9,0,9,9,9
	dc.b 0,0,0,9,9,9,0,9,9,9,0,9,9,9,0,9,9,9,0,9,9,0,9,0
	dc.b 0,0,9,0,9,0,0,9,0,9,0,0,0,9,0,0,9,0,0,9,0,0,0,0

Keymap_U 		equ 0
Keymap_D 		equ 1
Keymap_L 		equ 2
Keymap_R 		equ 3
Keymap_F1 		equ 4
Keymap_F2 		equ 5
Keymap_F3 		equ 6
Keymap_Pause 	equ 7
Keymap_AnyFire 	equ %11001111


ScrollingMessage:															
		dc.b "Written By Keith S, original DOS game by Mark Elendt... "
		dc.b "Thanks to Shane O'Brien,Oleg Tcymbaliuk,Barry White,Brainslave,Ervin Pajor,Gabino Sanchez,Paul Barrick,Richard Farrell,Roland Rzasa,"
		dc.b "Robsoft,Sal Gunduz & all my patreons",255

		;Thanks to ALL My patreons: 
		;Alejandro Perez, Benny Damsgaard, Blastar, DavidB, Dean Howell, Dimitris Topouzis, Ivar Fiske
		;James Ford, Laurens Holst, Michael Steil, Remax & Themistocles/Gryzor
		;Shane O'Brien, Paul Barrick, Oleg Tcymbaliuk, Roland Rzasa, Brainslave, Sal Gunduz, Richard Farrell,
		;Barry White, Robsoft, Ervin Pajor
		
WebSite:		 dc.b "www.chibiakumas.com/68000",255
HighScoreMessage:dc.b "HiScore:",255
PauseMessage:    dc.b "Paused",255

	
GameOver:   dc.b "You're dead!",255
GameOver2: 	dc.b "('cos you suck!)",255
NewHiscore: dc.b "New Hiscore!",255


	even
	include "\SrcALL\V1_RamArea.asm"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;				Ram Area - May not be possible on all systems!!!
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	ifnd UserRam
	
UserRam:
	ds $1000
	endif
	
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	ifd BuildAMI			;Amiga sound definitions
WaveFormNoise:
	dc.b	195,	184,	71,	82,	141,	186,	62,	131
	dc.b	135,	217,	250,	193,	80,	152,	194,	2
	dc.b	228,	51,	171,	121,	73,	117,	107,	210
	dc.b	106,	228,	241,	131,	229,	150,	118,	81
	dc.b	195,	184,	71,	82,	141,	186,	62,	131
	dc.b	195,	184,	71,	82,	141,	186,	62,	131
	dc.b	135,	217,	250,	193,	80,	152,	194,	2
	dc.b	228,	51,	171,	121,	73,	117,	107,	210
	dc.b	106,	228,	241,	131,	229,	150,	118,	81
	dc.b	195,	184,	71,	82,	141,	186,	62,	131
WaveFormNoiseEnd:

WaveFormTone:
	;dc.b 127,-127,127,-127,127,-127,127,-127,127,-127,127,-127,127,-127,127,-127
	dc.b 0,90,0,90,0,90,0,90,0,90,0,90,0,90,0,90,0,90,0,90,0,90,0,90,0,90,0,90,0,90,0,90
WaveFormToneEnd:	
	
	endif
	
	include "\SrcALL\V1_Footer.asm"