    SECTION TEXT

    ; System call to execute a function in Supervisor mode.
    ; If we don't run our code in supervisor mode, we
    ; cannot write to the registers to set up screen pointer
    ; and palette.

    pea    super_run    ; Push address pointer to stack 
    move.w  #$26,-(sp)  ; XBIOS call to Supexec.
    trap    #14         ; Software interript #14 -> XBIOS
    addq.w  #6,sp       ; Fix stack pointer (not really needed in this case.)

.halt   bra.s   .halt

super_run:

    ; On ST, the screen address should be aligned by 256 bytes.
    ; The add.w and clr.b below takes care of that. Note that
    ; the screen_mem reservation is 32000 + 256 extra bytes.

    move.l  #screen_mem,d0  ; Move address to screen mem to d0
    add.l   #$ff,d0         ; Add 255 d0 address
    clr.b   d0              ; Clear lowest byte in address
    move.l  d0,a6           ; Store screen pointer in a6

    lsr.w   #8,d0           ;we need to convert $ABCD00 into $ABCD
    move.l  d0,$ffff8200.w	;store the resulting 16 bits into the register

    ; Set palette
    movea.w #$8240,a1   ; Pointer to palette entries.
    moveq   #0005,d0       ; Color is black.
    moveq   #15,d1      ; loop 16 times. (dbra loops until dn == -1 )
.clear_palette
    move.w  d0,(a1)+
    dbra.w  d1,.clear_palette

	
	;Screen Res
    move.w  d0,$ffff8260.w		;00=320x240 4 planes


	move.w  #$0770,d0	;-----RRR-GGG-BBB
    move.w  d0,$ffff8242.w ; Color 1
	move.w  #$0077,d0	;-----RRR-GGG-BBB
    move.w  d0,$ffff8244.w ; Color 2
	move.w  #$0700,d0	;-----RRR-GGG-BBB
    move.w  d0,$ffff8246.w ; Color 2
	move.w  #$0770,d0	;-----RRR-GGG-BBB
    move.w  d0,$ffff825E.w ; Color 2