
;-----------------------------------------------------------------------

Delay		MOVE.W	#$95CE,D1	; delay a long time (about 1/20 sec?)
.1		DBRA	D1,.1
		DBRA	D0,Delay
		RTS



PrintChar:
	moveM.l d0-d7/a0-a7,-(sp)
		and #$FF,d0
		sub #32,d0
PrintCharAlt:		
		;			
		Move.L  #$40000003,d5
		Move.L #0,d4
		Move.B (Cursor_Y),D4
		ifd ScrWid256
			add.B #2,D4
		endif
		rol.L #8,D4
		rol.L #8,D4
		rol.L #7,D4
		;rol.L #2,D4
		add.L D4,D5
		
		Move.B (Cursor_X),D4
		ifd ScrWid256
			add.B #4,D4
		endif
		rol.L #8,D4
		rol.L #8,D4
		rol.L #1,D4
		add.L D4,D5
		
		MOVE.L	D5,(VDP_ctrl)			; C00004 write next character to VDP
		MOVE.W	D0,(VDP_data)			; C00000 store next word of name data

		addq.b #1,(Cursor_X)
		move.b (Cursor_X),d0
		cmp.b #39,d0
		bls nextpixel_Xok
		jsr NewLine
nextpixel_Xok:
		
	moveM.l (sp)+,d0-d7/a0-a7
	rts


	
	
PrintString:
		move.b (a3)+,d0
		cmp.b #255,d0
		beq PrintString_Done
		jsr PrintChar
		bra PrintString
PrintString_Done:		
	rts

NewLine:
	addq.b #1,(Cursor_Y)
	move.b #0,(Cursor_X)
	rts	
	
Locate:
	move.b d6,(Cursor_Y)
	move.b d3,(Cursor_X)
	
	rts	
	
	
cls:
	clr.b d3
	clr.b d6
	jsr Locate
	move.L #40*25-1,d1
clsAgain:
	move #' ',d0
	jsr PrintChar
	dbra d1,clsAgain
	rts
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	

		EVEN
;-----------------------------------------------------------------------

Regs1		DC.L	$00008000	; D5 = VDP register 0 write command
		DC.L	0		; D6 = unused
		DC.L	$00000100	; D7 = video register offset
		DC.L	0		; A0 = unused
		DC.L	HW_Version	; A1 = hardware version register
		DC.L	TMSS_reg	; A2 = TMSS register
		DC.L	VDP_data	; A3 = VDP data
		DC.L	VDP_ctrl	; A4 = VDP control / status
					; A5 = pointer to the following data:

		; VDP register initialization (24 bytes)
		DC.B	$04	; reg  0 = mode register 1: no H interrupt
		DC.B	$14	; reg  1 = mode register 2: blanked, no V interrupt, DMA enable
		DC.B	$30	; reg  2 = name table base for scroll A: $C000
		DC.B	$3C	; reg  3 = name table base for window:   $F000
		DC.B	$07	; reg  4 = name table base for scroll B: $E000
		DC.B	$6C	; reg  5 = sprite attribute table base: $D800
		DC.B	$00	; reg  6 = unused register: $00
		DC.B	$00	; reg  7 = background color: $00
		DC.B	$00	; reg  8 = unused register: $00
		DC.B	$00	; reg  9 = unused register: $00
		DC.B	$FF	; reg 10 = H interrupt register: $FF (esentially off)
		DC.B	$00	; reg 11 = mode register 3: disable ext int, full H/V scroll
		DC.B	$81	; reg 12 = mode register 4: 40 cell horizontal mode, no interlace
		DC.B	$37	; reg 13 = H scroll table base: $FC00
		DC.B	$00	; reg 14 = unused register: $00
		DC.B	$01	; reg 15 = auto increment: $01
		DC.B	$01	; reg 16 = scroll size: V=32 cell, H=64 cell
		DC.B	$00	; reg 17 = window H position: $00
		DC.B	$00	; reg 18 = window V position: $00
		DC.B	$FF	; reg 19 = DMA length count low:   $00FF
		DC.B	$FF	; reg 20 = DMA length count high:  $FFxx
		DC.B	$00	; reg 21 = DMA source address low: $xxxx00
		DC.B	$00	; reg 22 = DMA source address mid: $xx00xx
		DC.B	$80	; reg 23 = DMA source address high: VRAM fill, addr = $00xxxx

		; PSG initialization: set all channels to minimum volume
		DC.B	$9F,$BF,$DF,$FF

;-----------------------------------------------------------------------

Regs2		DC.L	0		; D4 = unused
		DC.L	$45940003	; D5 = VRAM write to middle of screen, addr = $C594
		DC.L	0	; D6 = size of charset data
		DC.L	0		; D7 = unused
		DC.L	CRAM_tab	; A2 = CRAM table
		DC.L	0		; A3 = unused
		DC.L	VDP_ctrl	; A4 = VDP control / status
		DC.L	VDP_data	; A5 = VDP data
		DC.L	0		; A6 = unused
					; A1 = pointer to the following data:

		; CRAM initialization
CRAM_tab
		DC.W	(CRAM_end-CRAM_tab)/2-2	; number of entries - 1
		DC.W	$0500,$00EE,$0EE8,$FFFF,$0500,$00EE,$0EE8,$FFFF,$0500,$00EE,$0EE8,$FFFF,$0500,$00EE,$0EE8,$00FF ----BBB- GGG-RRR-
CRAM_end
