UserRam equ $101000




; freemlib for Neo-Geo Example 01: Hello World on the Fix Layer
;==============================================================================;
	; defines
	;include "../../src_68k/inc/neogeo.inc"
MESS_OUT			equ $C004CE ; Fix layer message output
SYSTEM_IO			equ $C0044A ; Reads player inputs (and cabinet if MVS)
LSPC_ADDR			equ $3C0000 ; VRAM Address
LSPC_DATA			equ $3C0002 ; VRAM Data
LSPC_INCR			equ $3C0004 ; VRAM Increment
LSPC_MODE			equ $3C0006 ; LSPC Mode
LSPC_IRQ_ACK		equ $3C000C ; Interrupt acknowlege
LSP_1st				equ $C004C8 ; Clear SCB2-4, first SCB1 tilemap
PALETTES			equ $400000 ; $400000-$401FFF
FIX_CLEAR			equ $C004C2 ; Clear Fix layer
SYSTEM_RETURN		equ $C00444 ; Returns from the game to the BIOS
PALETTE_BANK1		equ $3A000F ; (byte) Palette bank 1 register	
REG_DIPSW			equ $300001 ; Read Hardware DIPs [active low], Kick watchdog (a.k.a. "WATCH_DOG")
SYSTEM_INT1			equ $C00438 ; System VBlank
	;include "../../src_68k/inc/ram_bios.inc"
BIOS_MESS_POINT equ $10FDBE ; (long) pointer to MESS_OUT buffer
BIOS_MESS_BUSY equ $10FDC2 ; (word) 0=run MESS_OUT, 1=skip MESS_OUT
BIOS_SYSTEM_MODE2 equ $10FE8E ; (word)
BIOS_USER_REQUEST equ $10FDAE ; (byte) Command for USER ($122)
BIOS_SYSTEM_MODE equ $10FD80 ; (byte) VBL for $00=system,$80=game
BIOS_WORKRAM equ $10F300
	;include "../../src_68k/inc/mess_defs.inc" ; used for Japanese text
;------------------------------------------------------------------------------;
	; headers
	
;	include "header_68k.inc"
; 68000 Header
	dc.l	$0010F300		; Initial Supervisor Stack Pointer (SSP)
	dc.l	$00C00402		; Initial PC			(BIOS $C00402)
	dc.l	$00C00408		; Bus error/Monitor		(BIOS $C00408)
	dc.l	$00C0040E		; Address error			(BIOS $C0040E)
	dc.l	$00C00414		; Illegal Instruction	(BIOS $C00414)
	dc.l	$00C00426		; Divide by 0
	dc.l	$00C00426		; CHK Instruction
	dc.l	$00C00426		; TRAPV Instruction
	dc.l	$00C0041A		; Privilege Violation	(BIOS $C0041A)
	dc.l	$00C00420		; Trace					(BIOS $C00420)
	dc.l	$00C00426		; Line 1010 Emulator
	dc.l	$00C00426		; Line 1111 Emulator
	dc.l	$00C00426		; Reserved
	dc.l	$00C00426		; Reserved
	dc.l	$00C00426		; Reserved
	dc.l	$00C0042C		; Uninitialized Interrupt Vector

	ifd		TARGET_CD
		dc.l	$00C00522		; Reserved
		dc.l	$00C00528		; Reserved
		dc.l	$00C0052E		; Reserved
		dc.l	$00C00534		; Reserved
		dc.l	$00C0053A		; Reserved
		dc.l	$00C004F2		; Reserved
		dc.l	$00C004EC		; Reserved
		dc.l	$00C004E6		; Reserved
		dc.l	$00C004E0		; Spurious Interrupt
	else
		dc.l	$00C00426		; Reserved
		dc.l	$00C00426		; Reserved
		dc.l	$00C00426		; Reserved
		dc.l	$00C00426		; Reserved
		dc.l	$00C00426		; Reserved
		dc.l	$00C00426		; Reserved
		dc.l	$00C00426		; Reserved
		dc.l	$00C00426		; Reserved
		dc.l	$00C00432		; Spurious Interrupt
	endif

; Interrupts
	ifd		TARGET_CD		; (CD systems swap INT2 and INT1)
		dc.l	IRQ2			; Level 2 interrupt (HBlank)
		dc.l	VBlank			; Level 1 interrupt (VBlank)
	else
		dc.l	VBlank			; Level 1 interrupt (VBlank)
		dc.l	IRQ2			; Level 2 interrupt (HBlank)
	endif

	dc.l	IRQ3			; Level 3 interrupt
	dc.l	$00000000		; Level 4 interrupt
	dc.l	$00000000		; Level 5 interrupt
	dc.l	$00000000		; Level 6 interrupt
	dc.l	$00000000		; Level 7 interrupt (NMI)

; Traps
	dc.l	$FFFFFFFF		; TRAP #0 Instruction
	dc.l	$FFFFFFFF		; TRAP #1 Instruction
	dc.l	$FFFFFFFF		; TRAP #2 Instruction
	dc.l	$FFFFFFFF		; TRAP #3 Instruction
	dc.l	$FFFFFFFF		; TRAP #4 Instruction
	dc.l	$FFFFFFFF		; TRAP #5 Instruction
	dc.l	$FFFFFFFF		; TRAP #6 Instruction
	dc.l	$FFFFFFFF		; TRAP #7 Instruction
	dc.l	$FFFFFFFF		; TRAP #8 Instruction
	dc.l	$FFFFFFFF		; TRAP #9 Instruction
	dc.l	$FFFFFFFF		; TRAP #10 Instruction
	dc.l	$FFFFFFFF		; TRAP #11 Instruction
	dc.l	$FFFFFFFF		; TRAP #12 Instruction
	dc.l	$FFFFFFFF		; TRAP #13 Instruction
	dc.l	$FFFFFFFF		; TRAP #14 Instruction
	dc.l	$FFFFFFFF		; TRAP #15 Instruction
	dc.l	$FFFFFFFF		; Reserved
	dc.l	$FFFFFFFF		; Reserved
	dc.l	$FFFFFFFF		; Reserved
	dc.l	$FFFFFFFF		; Reserved
	dc.l	$FFFFFFFF		; Reserved
	dc.l	$FFFFFFFF		; Reserved
	dc.l	$FFFFFFFF		; Reserved
	dc.l	$FFFFFFFF		; Reserved
	dc.l	$FFFFFFFF		; Reserved
	dc.l	$FFFFFFFF		; Reserved
	dc.l	$FFFFFFFF		; Reserved
	dc.l	$FFFFFFFF		; Reserved
	dc.l	$FFFFFFFF		; Reserved
	dc.l	$FFFFFFFF		; Reserved
	dc.l	$FFFFFFFF		; Reserved
	dc.l	$FFFFFFFF		; Reserved

	; Neo-Geo Cart Header [placed at $000100]
;==============================================================================;
	dc.b "NEO-GEO"
	dc.b $00 ; System Version (0=cart; 1/2 are used for CD games)

	dc.w $0FFF ; NGH number ($0000 is prohibited)

	dc.l $00080000 ; game prog size in bytes
	; $00040000 =  2Mbits/256KB
	; $00080000 =  4Mbits/512KB
	; $00100000 =  8Mbits/1MB
	; etc.

	dc.l $00108000 ; pointer to backup RAM block (first two bytes are debug dips)
	dc.w $0000 ; game save size in bytes

	dc.b $00 ; Eye catcher anim flag (0=BIOS,1=game,2=nothing)
	dc.b $00 ; Sprite bank for eyecatch if done by BIOS

	dc.l softDips_Japan  ; Software dips for Japan
	dc.l softDips_USA    ; Software dips for USA
	dc.l softDips_Europe ; Software dips for Europe

	jmp USER ; $122
	jmp PLAYER_START ; $128
	jmp DEMO_END ; $12E
	jmp COIN_SOUND ; $134

	dc.l $FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF
	dc.l $FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF
	dc.l $FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF
	dc.l $FFFFFFFF,$FFFFFFFF,$FFFFFFFF,$FFFFFFFF
	dc.l $FFFFFFFF,$FFFFFFFF

	;org $00000182
	dc.l TRAP_CODE ;pointer to TRAP_CODE

	; these next three are from Art of Fighting...
	;dc.l 0
	;dc.l 1
	;dc.l softDips_Spain ; Software dips for Spain
	; not sure if they're official or what, though.

	; security code required by Neo-Geo games

TRAP_CODE:
	dc.l $76004A6D,$0A146600,$003C206D,$0A043E2D
	dc.l $0A0813C0,$00300001,$32100C01,$00FF671A
	dc.l $30280002,$B02D0ACE,$66103028,$0004B02D
	dc.l $0ACF6606,$B22D0AD0,$67085088,$51CFFFD4
	dc.l $36074E75,$206D0A04,$3E2D0A08,$3210E049
	dc.l $0C0100FF,$671A3010,$B02D0ACE,$66123028
	dc.l $0002E048,$B02D0ACF,$6606B22D,$0AD06708
	dc.l $588851CF,$FFD83607
	dc.w $4E75

; Software Dip Switches (a.k.a. "soft dip")
;==============================================================================;
; setting up the soft dip (Japan)

softDips_Japan:
	dc.b "EXAMPLE SET J   " ; Game Name
	dc.w $FFFF ; Special Option 1
	dc.w $FFFF ; Special Option 2
	dc.b $FF ; Special Option 3
	dc.b $FF ; Special Option 4
	; Options
	dc.b $02 ; Option 1: 2 choices, default #0
	dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00 ; filler
	dc.b "OPTION 1J   " ; Option 1 description
	dc.b "CHOICE1 J   " ; Option choices
	dc.b "CHOICE2 J   "

;------------------------------------------------------------------------------;
; setting up the soft dip (USA)

softDips_USA:
	dc.b "EXAMPLE SET U   " ; Game Name
	dc.w $FFFF ; Special Option 1
	dc.w $FFFF ; Special Option 2
	dc.b $FF ; Special Option 3
	dc.b $FF ; Special Option 4
	; Options
	dc.b $02 ; Option 1: 2 choices, default #0
	dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00 ; filler
	dc.b "OPTION 1U   " ; Option 1 description
	dc.b "CHOICE1 U   " ; Option choices
	dc.b "CHOICE2 U   "

;------------------------------------------------------------------------------;
; setting up the soft dip (Europe)

softDips_Europe:
	dc.b "EXAMPLE SET E   " ; Game Name
	dc.w $FFFF ; Special Option 1
	dc.w $FFFF ; Special Option 2
	dc.b $FF ; Special Option 3
	dc.b $FF ; Special Option 4
	; Options
	dc.b $02 ; Option 1: 2 choices, default #0
	dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00 ; filler
	dc.b "OPTION 1E   " ; Option 1 description
	dc.b "CHOICE1 E   " ; Option choices
	dc.b "CHOICE2 E   "

	
	
;==============================================================================;
; USER
; Needs to perform actions according to the value in BIOS_USER_REQUEST.
; Must jump back to SYSTEM_RETURN at the end so the BIOS can have control.

USER:
	move.b	d0,REG_DIPSW		; kick watchdog
	lea		BIOS_WORKRAM,sp		; set stack pointer to BIOS_WORKRAM
	move.w	#0,LSPC_MODE		; Disable auto-animation, timer interrupts, set auto-anim speed to 0 frames
	move.w	#7,LSPC_IRQ_ACK		; ack. all IRQs

	move.w	#$2000,sr			; Enable VBlank interrupt, go Supervisor

	; Handle user request
	moveq	#0,d0
	move.b	(BIOS_USER_REQUEST).l,d0
	lsl.b	#2,d0				; shift value left to get offset into table
	lea		cmds_USER_REQUEST,a0
	movea.l	(a0,d0),a0
	jsr		(a0)

;------------------------------------------------------------------------------;
; BIOS_USER_REQUEST commands
cmds_USER_REQUEST:
	dc.l	userReq_StartupInit	; Command 0 (Initialize)
	dc.l	userReq_Eyecatch	; Command 1 (Custom eyecatch)
	dc.l	userReq_Game		; Command 2 (Demo Game/Game)
	dc.l	userReq_Game		; Command 3 (Title Display)

;------------------------------------------------------------------------------;
; userReq_StartupInit
; Initialize the backup work area.

userReq_StartupInit:
	move.b	d0,REG_DIPSW		; kick watchdog
	jmp		SYSTEM_RETURN

;------------------------------------------------------------------------------;
; userReq_Eyecatch
; Only to be fully coded if your game uses its own eyecatch (value at $114 is 1).
; Otherwise, jmp to SYSTEM_RETURN.

userReq_Eyecatch:
	move.b	d0,REG_DIPSW		; kick watchdog
	jmp		SYSTEM_RETURN

;------------------------------------------------------------------------------;
; userReq_Game
; This is the complex one. For this demo, we're only going to treat it as a
; combination of initialization and main loop, but for a real game, you might
; want to have BIOS_USER_REQUEST commands 2 and 3 do different things.

userReq_Game:
	move.b	d0,REG_DIPSW		; kick watchdog

	; perform your initialization

	; set up palettes
	move.b	d0,PALETTE_BANK1	; use palette bank 1
	lea		paletteData,a0		; load palette data start address into a0
	lea		PALETTES,a1			; load palette RAM start address into a1
	move.l	#(16*NUM_PALETTES)-1,d7 ; each palette is 16 colors; the -1 is for loop logic to work
.ldpal:
	move.w	(a0)+,(a1)+			; copy palette data from ROM to RAM
	dbra	d7,.ldpal			; loop logic; d7 is decremented and .ldpal loops

	
	move.l #$401FFE,a0
	move.w #$0007,(a0)	;Set Background color
	
	
	
	jsr		FIX_CLEAR			; clear fix layer, add borders on sides
	jsr		LSP_1st				; clear first sprite

	;jsr		CreateDisplay		; create initial display

; execution continues into main loop.
;------------------------------------------------------------------------------;
; mainLoop
; The game's main loop. This is where you run the actual game part.

	 